<?php

////////////////////////////////////////////////////////////////////////////
//                                                                        //
//   Sample code to check server status and send alert email on failure   //     
//                                                                        //
////////////////////////////////////////////////////////////////////////////


// Please configure the following variables!

// AlertDispatcher HTTP Server Domain
$http_server = 'http://localhost';

// AlertDispatcher HTTP Server Port
$http_port = 80;

// Email Variables
$emailserver   = 'smtp.gmail.com'; // sets GMAIL as the SMTP server
$emailport     = '465'; // GMAIL SSL port
$emailusername = 'yourgmail@gmail.com'; // GMAIL username
$emailpassword = 'yourgmailpassword'; // GMAIL password

$emailrecipientaddress = 'youremailaddress@yourcompany.com';
$emailrecipientname    = 'yourname';


//////////////////////
//   CHECK SERVER   //
//////////////////////

// Submit the following variables to the server.

$post_data = array(
    'USERNAME' => '', // Optional - Required only if you have configure this under HTTP Server Setup.
    'PASSWORD' => '' // Optional - Required only if you have configure this under HTTP Server Setup.
);

// Check server using the command checkserver.

$result = post_request($http_server . '/checkserver', $http_port, $post_data);

if ($result['status'] == 'ok') {
    // Print the result of the whole request.
    
    echo 'SendSMS Result: ' . $result['content'];
    
    $content = $result['content'];
    
    $pos = strpos($content, 'Running');
    
    if ($pos !== false) {
        echo '<hr />';
        echo 'Server UP!';
        
    } else {
        echo '<hr />';
        echo 'Server DOWN!';
        
        // Send email alert
        
        send_email('AlertDispatcher at ' . $http_server . ' is down!', "Error text: " . $content, $emailrecipientaddress, $emailrecipientname, $emailserver, $emailport, $emailusername, $emailpassword);
        
    }
    
} else {
    echo 'An error occured: ' . $result['error'];
    
    // Send email alert
    
    send_email('Unable to connect to AlertDispatcher at ' . $http_server . '!', "Error text: " . $result['error'], $emailrecipientaddress, $emailrecipientname, $emailserver, $emailport, $emailusername, $emailpassword);
    
}

//////////////////////////////////////////////////////////

function send_email($emailsubject, $emailbody, $emailrecipientaddress, $emailrecipientname, $emailserver, $emailport, $emailusername, $emailpassword)
{
    require_once('./public/class.phpmailer.php');
    $mail = new PHPMailer(true); // the true param means it will throw exceptions on errors, which we need to catch
    $mail->IsSMTP(); // telling the class to use SMTP
    try {
        $mail->SMTPDebug  = 1; // enables SMTP debug information (for testing)
        $mail->SMTPAuth   = true; // enable SMTP authentication
        $mail->SMTPSecure = "ssl"; // sets the prefix to the server
        $mail->Host       = $emailserver;
        $mail->Port       = $emailport;
        $mail->Username   = $emailusername;
        $mail->Password   = $emailpassword;
        $mail->AddReplyTo($emailrecipientaddress, 'AlertDispatcher');
        $mail->AddAddress($emailrecipientaddress, $emailrecipientname);
        $mail->SetFrom($emailrecipientaddress, 'AlertDispatcher');
        $mail->Subject = $emailsubject;
        $mail->Body    = $emailbody;
        $mail->Send();
        echo '<hr />';
        print "email sent!";
        
    }
    catch (phpmailerException $e) {
        echo '<hr />';
        echo $e->errorMessage(); //Pretty error messages from PHPMailer
        sleep(10);
        $mail->Send();
    }
    catch (Exception $e) {
        echo '<hr />';
        echo "Error encountered when sending password email.";
        echo $e->getMessage();
    }
}


//////////////////////////////////////////////////////////

function post_request($url, $port, $data, $referer = '')
{
    // Convert the data array into URL Parameters like a=b&foo=bar etc.
    $data = http_build_query($data);
    
    // parse the given URL
    $url = parse_url($url);
    
    if ($url['scheme'] != 'http') {
        die('Error: Only HTTP request are supported !');
    }
    
    // extract host and path:
    $host = $url['host'];
    $path = $url['path'];
    
    // open a socket connection on $port - timeout: 30 sec
    $fp = fsockopen($host, $port, $errno, $errstr, 30);
    
    if ($fp) {
        // send the request headers:
        fputs($fp, "POST $path HTTP/1.1\r\n");
        fputs($fp, "Host: $host\r\n");
        
        if ($referer != '')
            fputs($fp, "Referer: $referer\r\n");
        
        fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
        fputs($fp, "Content-length: " . strlen($data) . "\r\n");
        fputs($fp, "Connection: close\r\n\r\n");
        fputs($fp, $data);
        
        $result = '';
        while (!feof($fp)) {
            // receive the results of the request
            $result .= fgets($fp, 128);
        }
    } else {
        return array(
            'status' => 'err',
            'error' => "$errstr ($errno)"
        );
    }
    
    // close the socket connection:
    fclose($fp);
    
    // split the result header from the content
    $result = explode("\r\n\r\n", $result, 2);
    
    $header  = isset($result[0]) ? $result[0] : '';
    $content = isset($result[1]) ? $result[1] : '';
    
    // return as structured array:
    return array(
        'status' => 'ok',
        'header' => $header,
        'content' => $content
    );
}
//////////////////////////////////////////////////////////


?>
