<?php

////////////////////////////////////////////////////////////////////////////
//                                                                        //
//    Sample code to send Alert using PHP script and check send status    //     
//                                                                        // 
////////////////////////////////////////////////////////////////////////////


// Configure the following variables!

// AlertDispatcher HTTP Server Domain
$http_server = 'http://localhost';

// AlertDispatcher HTTP Server Port
$http_port = 80;


//////////////////////
//   SEND MESSAGE   //
//////////////////////

// Submit the following variables to the server.

$post_data = array(
    'N' => '123456789', // Mobile number, Email address or the Addressbook user/group name. Use comma separator if there is more than one item.
    'M' => 'Hello World from PHP', // Message text
    'P' => '2', // Optional - Message priority - from 1 (lowest priority) to 4 (highest priority).  Default is 2.
    // 'D' => '2012-12-01 20:00:00',// Optional - Scheduled DateTime to send - format: YYYY-MM-DD HH:MM:SS
    'MODEMPORT' => '0', // Optional - Refers to the COM port of the modem you intend to use. 0 means auto.   
    'USERNAME' => '', // Optional - Required only if you have configure this under HTTP Server Setup.
    'PASSWORD' => '' // Optional - Required only if you have configure this under HTTP Server Setup.
);

// Send alert using the command sendsms.

$result = post_request($http_server . '/sendsms', $http_port, $post_data);

if ($result['status'] == 'ok') {
    // Print the result of the whole request.
    
    echo 'SendSMS Result: ' . $result['content'];
    
    $content       = $result['content'];
    $separator     = '|';
    $response_code = substr($content, 0, 6);
    
    // Print the response code, SMS888 means that the message has been sent successfully. Please refer to the user guide for other codes.
    
    echo '<br /><br />';
    echo 'Response Code: ' . $response_code;
    
    $remainder = $content;
    
    if ($response_code == 'SMS888') {
        $pos       = strpos($remainder, $separator);
        $remainder = substr($content, $pos + 4, 100);
        $pos       = strpos($remainder, $separator);
        $id        = substr($remainder, 0, $pos);
        
        // Print the message ID - this will be required for checking the send status.
        
        echo '<br />';
        echo 'ID:' . $id;
    }
    
    $pos     = strpos($remainder, $separator);
    $remarks = substr($remainder, $pos + 1, 100);
    
    echo '<br />';
    echo 'Remarks:' . $remarks;
    
} else {
    echo 'An error occured: ' . $result['error'];
}

///////////////////////////
//   QUERY SEND STATUS   //
///////////////////////////

// Query only if ID is available.
if ($id != '') {
    sleep(10);
    
    // Check send status.
    
    $post_data = array(
        'ID' => $id // Message ID 
    );
    
    $result = post_request($http_server . '/sendstatus', $http_port, $post_data);
    
    if ($result['status'] == 'ok') {
        // Print the result of the whole request.
        echo '<hr />';
        echo 'SendStatus Result: ' . $result['content'];
        
        $content   = $result['content'];
        $separator = '|';
        $pos       = strpos($content, $separator);
        $remainder = substr($content, $pos + 7, 100);
        $pos       = strpos($remainder, $separator);
        $status    = substr($remainder, 0, $pos);
        
        // Print the status code. 4 means success, please refer to the user guide for other codes.
        echo '<br /><br />';
        echo 'Status: ' . $status;
        
        $pos       = strpos($remainder, $separator);
        $remainder = substr($remainder, $pos + 7, 100);
        $pos       = strpos($remainder, $separator);
        $error     = substr($remainder, 0, $pos);
        
        // Print the error text if any.
        echo '<br />';
        echo 'Error: ' . $error;
        
        $pos       = strpos($remainder, $separator);
        $timestamp = substr($remainder, $pos + 9, 100);
        
        // Print the processed timestamp.
        echo '<br />';
        echo 'Processed Timestamp: ' . $timestamp;
        
    } else {
        echo 'An error occured: ' . $result['error'];
    }
    
}

//////////////////////////////////////////////////////////

function post_request($url, $port, $data, $referer = '')
{
    // Convert the data array into URL Parameters like a=b&foo=bar etc.
    $data = http_build_query($data);
    
    // parse the given URL
    $url = parse_url($url);
    
    if ($url['scheme'] != 'http') {
        die('Error: Only HTTP request are supported !');
    }
    
    // extract host and path:
    $host = $url['host'];
    $path = $url['path'];
    
    // open a socket connection on $port - timeout: 30 sec
    $fp = fsockopen($host, $port, $errno, $errstr, 30);
    
    if ($fp) {
        // send the request headers:
        fputs($fp, "POST $path HTTP/1.1\r\n");
        fputs($fp, "Host: $host\r\n");
        
        if ($referer != '')
            fputs($fp, "Referer: $referer\r\n");
        
        fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
        fputs($fp, "Content-length: " . strlen($data) . "\r\n");
        fputs($fp, "Connection: close\r\n\r\n");
        fputs($fp, $data);
        
        $result = '';
        while (!feof($fp)) {
            // receive the results of the request
            $result .= fgets($fp, 128);
        }
    } else {
        return array(
            'status' => 'err',
            'error' => "$errstr ($errno)"
        );
    }
    
    // close the socket connection:
    fclose($fp);
    
    // split the result header from the content
    $result = explode("\r\n\r\n", $result, 2);
    
    $header  = isset($result[0]) ? $result[0] : '';
    $content = isset($result[1]) ? $result[1] : '';
    
    // return as structured array:
    return array(
        'status' => 'ok',
        'header' => $header,
        'content' => $content
    );
}
//////////////////////////////////////////////////////////


?>
